"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const R = __importStar(require("ramda"));
const protocol_1 = require("@melonproject/protocol");
const types_1 = require("../../types");
const price_1 = require("@melonproject/token-math/price");
exports.fetchOasisDexOrders = (options) => __awaiter(this, void 0, void 0, function* () {
    const environment = R.prop('environment', options);
    const contract = R.path([
        'environment',
        'deployment',
        'melonContracts',
        'adapters',
        'matchingMarketAccessor',
    ], options);
    const exchange = R.path([
        'environment',
        'deployment',
        'thirdPartyContracts',
        'exchanges',
        'matchingMarket',
    ], options);
    const bidsCall = protocol_1.getActiveOasisDexOrders(environment, contract, {
        targetExchange: exchange.toString(),
        sellAsset: options.pair.quote.address.toString(),
        buyAsset: options.pair.base.address.toString(),
    });
    const asksCall = protocol_1.getActiveOasisDexOrders(environment, contract, {
        targetExchange: exchange,
        sellAsset: options.pair.base.address,
        buyAsset: options.pair.quote.address,
    });
    const [bidsResponse, asksResponse] = yield Promise.all([bidsCall, asksCall]);
    const bids = bidsResponse.map((order) => {
        return {
            id: Buffer.from(`${types_1.Exchange.OASIS_DEX}:${order.id}`).toString('base64'),
            type: types_1.OrderType.BID,
            exchange: types_1.Exchange.OASIS_DEX,
            trade: price_1.createPrice(order.buy, order.sell),
        };
    });
    const asks = asksResponse.map((order) => {
        return {
            id: Buffer.from(`${types_1.Exchange.OASIS_DEX}:${order.id}`).toString('base64'),
            type: types_1.OrderType.ASK,
            exchange: types_1.Exchange.OASIS_DEX,
            trade: price_1.createPrice(order.sell, order.buy),
        };
    });
    console.log({
        targetExchange: exchange,
        sellAsset: options.pair.base.address,
        buyAsset: options.pair.quote.address,
    });
    console.log(bids, asks);
    return [].concat(bids, asks);
});
